#pragma semicolon 1

#include <sourcemod>
#include <sdktools_functions>
#include <vip>

public Plugin:myinfo = 
{
	name	= "VIP [Kill Bonus]",
	author	= "wS",
	version = "1.1.1"
};

enum VipModule
{
	kill_hp = 0,
	kill_cash
};

new const String:ITEM_NAME[][] = 
{
	"kill_hp",
	"kill_cash"
};

new g_bAccess[MAXPLAYERS + 1][VipModule];
new g_ItemID[VipModule];
new g_LimitHp, g_LimitCash;

public OnPluginStart()
{
	for (new VipModule:module; module < VipModule; module++)
	{
		if (!(g_ItemID[module] = VIP_RegisterItem(ITEM_NAME[module], VIP_ITEM_TOGGLE)))
			SetFailState("VIP_RegisterItem error (%s)", ITEM_NAME[module]);
	}

	LoadTranslations("vip_modules_description.phrases");
	
	///
	new Handle:hCvar	= CreateConVar("kill_hp_limit",		"0",		"Health limit (0 = off)");
	g_LimitHp			= GetConVarInt(hCvar);
	HookConVarChange(hCvar, cvar_hp);
	hCvar				= CreateConVar("kill_cash_limit",	"16000",	"Cash limit");
	g_LimitCash			= GetConVarInt(hCvar);
	HookConVarChange(hCvar, cvar_cash);
	AutoExecConfig(true, "kill_bonus", "vip/modules/kill_bonus");
	///

	HookEvent("player_death", player_death, EventHookMode_Post);
}

public cvar_hp	(Handle:hCvar, const String:OldValue[], const String:NewValue[])	g_LimitHp	= StringToInt(NewValue);
public cvar_cash(Handle:hCvar, const String:OldValue[], const String:NewValue[])	g_LimitCash	= StringToInt(NewValue);

///////////////////////////////////////////////////////////////////////////////////

public bool:VIP_CurrentItemValue(client, ItemID, String:ItemValue[], ItemValueSize)
{
	new VipModule:module = wS_ItemIDToModule(ItemID);
	if (g_bAccess[client][module])
	{
		IntToString(g_bAccess[client][module], ItemValue, ItemValueSize);
		return true;
	}
	ItemValue[0] = 0;
	return false;
}

public bool:VIP_Description(client, ItemID, String:ItemValue[ITEM_INFO_LENGTH], String:description[], description_size)
{
	new VipModule:module = wS_ItemIDToModule(ItemID);
	FormatEx(description, description_size, "%T", ITEM_NAME[module], client, StringToInt(ItemValue));
	return true;
}

public VipGiveAction:VIP_GiveAccess(client, ItemID, String:ItemValue[ITEM_INFO_LENGTH], bool:bCallAfterAdminAction, CURRENT_ACCESS, Handle:kv)
{
	return UpdateAccess(client, ItemValue, wS_ItemIDToModule(ItemID));
}

public VIP_TakeAccess(client, ItemID, bool:bToggledByClient)
{
	new VipModule:module = wS_ItemIDToModule(ItemID);
	g_bAccess[client][module] = 0;
	VIP_NotifyItemStatusChanged(client, ITEM_NAME[module], false);
}

stock VipGiveAction:UpdateAccess(client, String:ItemValue[ITEM_INFO_LENGTH], VipModule:module)
{
	if (!ItemValue[0])
		return VGA_ValueNotSpecified;
	
	new value = StringToInt(ItemValue);
	if (!value)
		return VGA_BadValue;
	
	if (module == kill_cash && value > g_LimitCash)
		value = g_LimitCash;
	
	if (value == g_bAccess[client][module])
		return VGA_SameValue;
	
	g_bAccess[client][module] = value;
	
	IntToString(value, ItemValue, ITEM_INFO_LENGTH);
	VIP_NotifyItemStatusChanged(client, ITEM_NAME[module], true, ItemValue, 16);

	return VGA_Continue;
}

///////////////////////////////////////////////////////////////////////////////////

stock VipModule:wS_ItemIDToModule(ItemID)
{
	for (new VipModule:module = VipModule:0; module < VipModule; module++)
	{
		if (g_ItemID[module] == ItemID)
			return module;
	}
	return VipModule:0;
}

public player_death(Handle:event, const String:name[], bool:silent)
{
	new killer = GetClientOfUserId(GetEventInt(event, "attacker"));
	if (killer > 0 && (g_bAccess[killer][kill_hp] || g_bAccess[killer][kill_cash]) && GetClientTeam(killer) != GetClientTeam(GetClientOfUserId(GetEventInt(event, "userid"))))
		CreateTimer(0.1, CSGOwantTimer_why_omg, killer, TIMER_FLAG_NO_MAPCHANGE);
}

public Action:CSGOwantTimer_why_omg(Handle:timer, any:killer)
{
	if (!IsClientInGame(killer))
		return Plugin_Stop;

	if (g_bAccess[killer][kill_hp] && IsPlayerAlive(killer))
	{
		new hp = GetEntProp(killer, Prop_Send, "m_iHealth") + g_bAccess[killer][kill_hp];
		if (g_LimitHp > 0 && hp > g_LimitHp) hp = g_LimitHp;
		if (hp > 0) SetEntProp(killer, Prop_Send, "m_iHealth", hp);
		else ForcePlayerSuicide(killer);
	}

	if (g_bAccess[killer][kill_cash])
	{
		new ch = GetEntProp(killer, Prop_Send, "m_iAccount") + g_bAccess[killer][kill_cash];
		if (ch < 0) ch = 0;
		else if (ch > g_LimitCash) ch = g_LimitCash;
		SetEntProp(killer, Prop_Send, "m_iAccount", ch);
	}

	return Plugin_Stop;
}

public OnClientDisconnect(client)
{
	for (new VipModule:module; module < VipModule; module++)
		g_bAccess[client][module] = 0;
}